{************************************************************}
{*                 Unit Cfgrd3                              *}
{*               Text config file reader                    *}
{*       (c) 1997 by Dmitry Beloshistov [-=BDS=-]           *}
{*          e-mail: torin@kerin.donetsk.ua                  *}
{************************************************************}

Unit CfgRd3;
{$F+,O+,V-}
Interface
Uses Objects,FManage,FaFuncs,Dos;

Type
     PCfgReader=^TCfgReader;
     TCfgReader=object(TObject)
                 Error:boolean;
                 PCfgCol:PStringCollection;
                 Constructor Init(CfgFileName:string);
                 Destructor Done; virtual;
                 Procedure GetCfgFlag(CfgFlagName:string;
                                      var CfgValue:string);
                 Function sGetFlag(CfgFlagName:string):string;
                 Function nGetFlag(CfgFlagName:string):longint;
                 Function rGetFlag(CfgFlagName:string):real;
                end;

Function ReadConfigFile(ConfigFile:String):PCfgReader;

const CommentEqu:char='=';

Implementation

Function StartParh:String;
var D,N,E:String;
begin
 FFSplit(ParamStr(0),D,N,E);
 StartPath:=Dls(D);
end;

Function EmptyStr(s:string):boolean;
begin
 if delspace(s)<>'' then EmptyStr:=false
 else EmptyStr:=true;
end;

Constructor TCfgReader.Init(CfgFileName:string);
var F:text;
    Buf:PByteArray;
    s:string;
begin
 Inherited Init;
 PCfgCol:=New(PStringCollection,Init(1,1));
 Error:=false;
 if Not(FileExist(CfgFileName)) then Error:=true
 else
  begin
   New(Buf);
   Assign(f,CfgFileName);
   SetTextBuf(f,Buf^);
   Reset(f);
   while not eof(f) do
    begin
     readln(f,s);
     DelComment(s);
     if s<>'' then PCfgCol^.Insert(NewStr(s));
    end;
   close(f);
   Dispose(Buf);
  end;
end;

Destructor TCfgReader.Done;
begin
 Dispose(PCfgCol,Done);
 Inherited Done;
end;

Procedure TCfgReader.GetCfgFlag(CfgFlagName:string; var CfgValue:string);
label l1;
var Flag:boolean;
    SSearch:string;
    SSearch2:string;
    sbuf:string;

 Procedure SearchFlag(Item:PString); far;
 var s:string;
     s2:string;
 begin
  s:=Item^;
  s2:=s;
  S:=UpperCase(s);
  if Pos(UpperCase(CfgFlagName)+CommentEqu,delspace(s))<>0 then
   begin
    if SSearch<>'' then SSearch2:=s2 else SSearch:=s2;
    Flag:=true;
   end;
 end;

begin
 SSearch:=''; SSearch2:='';
 Flag:=false;
 PCfgCol^.ForEach(@SearchFlag);
 if Flag then
   begin
    if SSearch='' then goto l1;
    sbuf:='';
    while SSearch[1]<>CommentEqu do begin sbuf:=sbuf+SSearch[1]; delete(SSearch,1,1);end;
    Delete(SSearch,1,1);sbuf:=delspace(sbuf);
    if UpperCase(Sbuf)=UpperCase(CfgFlagName) then CfgValue:=SSearch
    else begin
          if SSearch2='' then goto l1;
          sbuf:='';
  while SSearch2[1]<>CommentEqu do begin sbuf:=sbuf+SSearch2[1]; delete(SSearch2,1,1); end;
          Delete(SSearch2,1,1);sbuf:=delspace(sbuf);
          if UpperCase(Sbuf)=UpperCase(CfgFlagName) then CfgValue:=SSearch2;
         end;
   end
 else begin
        l1:
        CfgValue:=''; {not found!!!}
      end;
end;

Function TCfgReader.sGetFlag(CfgFlagName:string):string;
var s:string;
begin
 GetCfgFlag(CfgFlagName,s);
 sGetFlag:=Trim(s);
end;

Function TCfgReader.nGetFlag(CfgFlagName:string):longint;
var s:string;
begin
 GetCfgFlag(CfgFlagName,s);
 if delspace(s)<>'' then nGetFlag:=StrToInt(delspace(s))
 else nGetFlag:=-1;
end;

Function TCfgReader.rGetFlag(CfgFlagName:string):real;
var s:string;
    R:real;
    Er:integer;
begin
 GetCfgFlag(CfgFlagName,s);
 s:=delspace(s);
 if s<>'' then
     begin
      val(s,R,Er);
      if Er<>0 then rGetFlag:=-1 else rGetFlag:=R;
     end
 else rGetFlag:=-1;
end;


Procedure SetCorectParam(var Param:Byte; MaxParam,DefParam:Byte);
begin
 if Param>MaxParam then Param:=DefParam;
end;

Function SetCorectPath(SPath,DefParam:string):string;
var D:DirStr; N:NameStr; E:ExtStr;
begin
 if SPath='' then SetCorectPath:=StartPath+'\'+DefParam
 else begin
       FSplit(SPath,D,N,E);
       if (D<>'') and DirExist(D) then SetCorectPath:=SPath
       else SetCorectPath:=StartPath+'\'+DefParam;
      end;
end;


Function ReadConfigFile(ConfigFile:String):PCfgReader;
var s:string;
    PCfgR:PCfgReader;
begin
 PCfgR:=New(PCfgReader,Init(StartPath+'\'+ConfigFile)); {19-04-99,BDS}
 if PCfgR^.Error then
  begin
   Dispose(PCfgR,Done);
   ReadConfigFile:=nil;
  end
 else ReadConfigFile:=PCfgR;
end;

end.

